



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【xsy1230】 树(tree) 点分治+线段树</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【xsy1230】 树(tree) 点分治+线段树</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 01:32:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目大意：有一棵$n$个节点的树，点的标号为$1$到$n$。树中的边有边权。给你$m$个询问，每个询问包含三个参数$l,r,pos$,你要求出标号在$l$到$r$之间的所有点中，到节点$pos$距离最近的点离$pos$有多远。</p>
<p>数据范围：$n,m,l,r,pos&le;10^5$，强制在线。</p>
<p>此题我强制在线两个变量打反了，$wa$了一发。</p>
<p>我们考虑点分治，对于节点x，我们在节点$x$上种一个线段树，保存以$x$为跟（点分治树树根）的子树内，每个节点距离x的距离。</p>
<p>对于一组查询，我们直接在点分治树上从下往上条，每跳到一个节点查询一次就可以了。</p>
<p>时间复杂度：$O(n\log^2\ n)$。</p>
<div>
<pre class="prettyprint linenums"> #include&lt;bits/stdc++.h&gt;<br />
 #define M 100005<br />
 #define INF 1e9<br />
 using namespace std;

 struct edge{int u,v,next;}e[M*]={}; int head[M]={},use=;<br />
 void add(int x,int y,int z){use++;e[use].u=y;e[use].v=z;e[use].next=head[x];head[x]=use;}

 int siz[M]={},vis[M]={},Minn=,minid=,n;<br />
 void dfssiz(int x,int fa){siz[x]=;for(int i=head[x];i;i=e[i].next) if(e[i].u!=fa&amp;&amp;vis[e[i].u]==) dfssiz(e[i].u,x),siz[x]+=siz[e[i].u];}<br />
 void dfsmin(int x,int fa,int fsiz){int maxn=fsiz-siz[x]; for(int i=head[x];i;i=e[i].next) if(e[i].u!=fa&amp;&amp;vis[e[i].u]==) dfsmin(e[i].u,x,fsiz),maxn=max(maxn,siz[e[i].u]);if(maxn&lt;Minn) Minn=maxn,minid=x;}<br />
 int makeroot(int x){Minn=M; dfssiz(x,); dfsmin(x,,siz[x]); return minid;}

 int lc[M*]={},rc[M*]={},minn[M*]={},root[M]={},cnt=;<br />
 void updata(int &amp;x,int l,int r,int k,int val){<br />
     if(!x) minn[x=++cnt]=INF; minn[x]=min(minn[x],val);<br />
     if(l==r) return; int mid=(l+r)&gt;&gt;;<br />
     (k&lt;=mid)?updata(lc[x],l,mid,k,val):updata(rc[x],mid+,r,k,val);<br />
 }<br />
 int query(int x,int l,int r,int ll,int rr){<br />
     if(x==||(ll&lt;=l&amp;&amp;r&lt;=rr)) return minn[x];<br />
     int mid=(l+r)&gt;&gt;,res=INF;<br />
     if(ll&lt;=mid) res=min(res,query(lc[x],l,mid,ll,rr));<br />
     if(mid&lt;rr) res=min(res,query(rc[x],mid+,r,ll,rr));<br />
     return res;<br />
 }<br />
 void build(int x,int fa,int dis,int &amp;Root){<br />
     updata(Root,,n,x,dis);<br />
     for(int i=head[x];i;i=e[i].next) if(e[i].u!=fa&amp;&amp;vis[e[i].u]==) build(e[i].u,x,dis+e[i].v,Root);<br />
 }

 int fa[M]={};<br />
 void solve(int x,int F){<br />
     x=makeroot(x); vis[x]=; fa[x]=F;<br />
     build(x,,,root[x]);<br />
     for(int i=head[x];i;i=e[i].next) if(vis[e[i].u]==) solve(e[i].u,x);<br />
 }<br />
 void ReadData(){<br />
     minn[]=INF;<br />
     scanf("%d",&amp;n);<br />
     for(int i=;i&lt;n;i++){<br />
         int x,y,z; scanf("%d%d%d",&amp;x,&amp;y,&amp;z);<br />
         add(x,y,z); add(y,x,z);<br />
     }<br />
     solve(,);<br />
 }

 int query(int l,int r,int pos){<br />
     int minn=INF;<br />
     for(int x=pos;x;x=fa[x]){<br />
         int disnow=query(root[x],,n,l,r);<br />
         int dispos=query(root[x],,n,pos,pos);<br />
         minn=min(minn,dispos+disnow);<br />
     }<br />
     return minn;<br />
 }<br />
 void Solve(){<br />
     int q,ans=; scanf("%d",&amp;q);<br />
     while(q--){<br />
         int l,r,pos; scanf("%d%d%d",&amp;l,&amp;r,&amp;pos); pos^=ans;<br />
         printf("%d\n",ans=query(l,r,pos));<br />
     }<br />
 }

 int main(){<br />
     ReadData();<br />
     Solve();<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e6jmq1.html">git命令分类图</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnym4k8.html">总结&colon;视频播放的四种实现方案&lpar;Native&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2exjvq.html">【tornado】系列项目（一）之基于领域驱动模型架构设计的京东用户管理后台</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnymdpq.html">GLOG使用注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmxom19.html">iOS开发之OCR光学识别储蓄卡以及信用卡</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnz6m6q.html">百度参投 Uber中国12亿美元融资已到账</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1v5zjq.html">CodeForces 681D Gifts by the List</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljwd719.html">JSP第七篇【简单标签、应用、DynamicAttribute接口】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzr5jg8.html">react入门（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z13639.html">在安卓代码中dp 和 sp 换算px</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjjpk59.html">利用python list 完成最简单的DB连接池</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdo35e9.html">2018JAVA面试题附答案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdz6dj9.html">js中的instanceof运算符</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwlpgx9.html">java Arrays数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/q251okoq.html">&lbrack;js&rsqb;js的表单验证onsubmit方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2gw40q.html">&lpar;19&rpar;3 moons and a planet that could have alien life</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emyz1k9.html">IntelliJ idea配置python</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pv4m3q.html">angularJS指令动态加载template</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44p2znq.html">N个点中寻找多个最近两点的计算O&lpar;N&sup2;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn2je33q.html">js点击复制某段文本方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdjz6zzq.html">Java中的内存划分</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1ved69.html">2018&period;09&period;22 牧场的安排（状压dp）</a>
			</li>
						<li><a href="https://www.batexi.com/a/953dr1z8.html">2018&period;07&period;04 BZOJ1336&amp;&amp;1337&colon; Balkan2002Alien最小圆覆盖</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7edme19.html">着重基础之&mdash;MySql Blob类型和Text类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpge7e9.html">Win7下U盘安装CentOS-7-x86&lowbar;64-DVD-1503-01</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v4vd5q.html">（并查集 贪心思想）Supermarket -- POJ --1456</a>
			</li>
						<li><a href="https://www.batexi.com/a/902yj24q.html">万能的ctrl&plus;shift&plus;F（Element &amp;&num;39&semi;beans&amp;&num;39&semi; cannot have character &lbrack;children&rsqb;&comma; because the type&amp;&num;39&semi;s content type is element-only&period;错误）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmlnog9.html">fastreport字体加粗</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjkpd08.html">【转】WPF中PasswordBox控件的Password属性的数据绑定</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppgxok9.html">解决由AJAX请求时forms认证实效的重新认证问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
